<%@page import="imagemed.dotcom.TransactionManager"%><%--
 * Component: cases
 *
 *  Processes commitments on storage of DICOM objects
 *
 *  @param cStudy        Study Instance UID of the study
 *  @param cObject       Set the store level of this dicom object
 *
 * Note:
 *   In the future HTTP commitment will be replaced by DICOM Storage Commitment
 *
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
--%><%@
	page import="imagemed.util.*, imagemed.imsession.*, imagemed.jsputil.*, imagemed.exception.*,
			java.io.*, java.sql.*, java.util.*"

%><%-- Helper function(s) --%><%!

	void DoResponse( HttpServletResponse response, JspWriter out, boolean res ) throws IOException {
		response.setContentType( "text/plain" );
		if ( res )
			response.setStatus( 200 );
		else
			response.setStatus( 500 );

		out.print( res );
	}

%><%

	IMSession is = new IMSession( request, response, out );

	String parObject = request.getParameter( "cObject" );
	String parStudy = request.getParameter( "cStudy" );
	String ip = request.getRemoteAddr();

	Syslog s = new Syslog( "commit", 0, IMEnvBase.getEnv( "LOG_FACILITY" ) );
	s.syslog( Syslog.LOG_INFO, parObject + " : " + parStudy + " : " + ip );

	//check if this transaction is the duplicate of a successful previous one - send 'true' result and do nothing
	String prevResult = null;
	TransactionManager tm = new TransactionManager( is );
	
	try {
		prevResult = tm.getAnswer();
	}
	catch ( Exception e ) {
		//legacy - no transaction id
	}
	
	if ( "true".equals( prevResult ) ) {
		DoResponse( response, out, true );
		return;
	}
			
	// check parameters
	if ( parObject == null || parStudy == null ) {
		s.syslog( Syslog.LOG_ERR, "Error : Missing parameter" );
		DoResponse( response, out, false );
		return;
	}

	String deviceID = null;
	try {
		Properties prpDevice = DotcomToolbox.checkClient( is, null, false );
		deviceID = prpDevice.getProperty( "ID" );
		if ( deviceID == null )
			throw new IMException( "Peer ID is null" );
	}
	catch ( Throwable th ) {
		String errMsg = th.getMessage() == null ? "EXCEPTION: " + th.toString() : th.getMessage();
		s.syslog( Syslog.LOG_ERR, errMsg );
		DoResponse( response, out, false );
		return;
	}

	// Remove commit_<deviceID> reference from OBJECTFILE
	if ( ReferenceCounter.removeReference( "OBJECTFILE", parStudy + "/" + parObject, "commit_" + deviceID ) ) {
		try {
			tm.setAnswer( "true" );		
		}
		catch( Exception e ) {
			//legacy - no transaction id
		}
		DoResponse( response, out, true );
		return;
	}

	// Check if parObject is SR. Old SRs are stored by pb-scp with SRt. prefix,
	// but from ReportManager with SR. prefix
//	if (parObject.startsWith("SRt")) {
//		parObject = Helper.replace(parObject,"SRt","SR");
//		ReferenceCounter.removeReference("commit_" + deviceID, parStudy + "/" + parObject, "OBJECTFILE");
//	}

	// Failed

	if ( true ) { // otherwise jsp will write extra \r\n
		DoResponse( response, out, false );
		return;
	}
%>