<%--
 ** Component: cases
 **
 ** Description:
 **  Creates pbs files to open studies with PracticeBuilder viewer.
 **
 ** Will check if any of the studies is locked, and gives an alert the open to be continued or not.
 ** Will pass list context in the pbs file to make the viewer able to get Previous/Next study from
 ** the list.
 **
 **  @param cGr               \n separated list or array of Study Instance UID of studies to be opened
 **  @param cUser             user name to be used in creating list context
 **  @param cLoginBack        back URL for the login page if the user session timed out 
 **  @param cDontCheckLock    "true" means do not check if the studies locked or not
 **  @param cPrevNext         "true" means pass list context to get Previous/Next study from the viewer
 **  @param cDictate          "true" means open the viewer in 'Dictate only' mode
 **  @param cOpenMan          Parameters used to search for studies to open via HTTP API interface - open Manager Window after studies load 
 **
 ** $Author$
 ** $Date$
 **
 *
 *  RCS File Name    : $RCSfile$
 *  RCS Revision     : $Revision$
 *  Locked by        : $Locker$
 *  Symbolic name    : $Name$
 *  State            : $State$
--%><%@
	page import = "imagemed.util.*, imagemed.tables.*, imagemed.imtables.*, java.util.*,imagemed.exception.IMContextException,
			 java.io.*,java.sql.*, imagemed.imsession.*, imagemed.jsputil.*, imagemed.http.*"
%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%// -------- Input Parameters -----------

	IMSession is = new IMSession( request, response, out ); 


	if ( is.request.getParameter("cLoginBack")==null ) {
		is.regDest = request.getHeader("Referer");
	}
	else {
		is.regDest = request.getParameter("cLoginBack");
	}
	
	try {
		if (!is.regOK()) {
			return;
		}
	}
	catch (IMContextException ice) {
		String strError = "The context has been expired, please reopen the study/studies from the worklist.";
		response.setContentType("text/html");
		response.setHeader("Error", strError);
		throw ice;
	}

	if ( is.regID==null ) {
		return;
	}

	GetpbsToolbox getpbsToolbox = new GetpbsToolbox( is );

	getpbsToolbox.collectAndCheckStudiesToOpen();
	getpbsToolbox.sendResponse();

	if ( true ) {
		return;
	}%>
