<%--
 * Component: cases
 *
 * Description:
 *    Returns the report for a study in a processable form for the viewer.
 *
 * Parameters:
 * 
 *    study : study instance uid of the study
 *    lock  : lock mode (defaults to 'lock', can also be 'breaklock')
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
--%><%@
	page import="imagemed.util.*,imagemed.imsession.*,imagemed.jsputil.*,java.util.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%

	IMSession is = new IMSession(request, response, out); 
	Syslog logger = new Syslog( "getrep", 0, IMEnvBase.getEnv( "LOG_FACILITY" ) );

	if ( ProxyToolbox.init( is, null, logger ) ) {
		// Session parameters were proxied from parent child, regID must be set. 
		if ( is.regID == null ) {
			logger.syslog( Syslog.LOG_ERR, "No user ID was received from parent/child");
			return;
		}
	}
	else {
		// Check regular user session
		if (!is.regOK()) {
			return;
		}
	}

	String parStudy = request.getParameter("study");
	
	// Translate Link Study UID to Source Study UID
	parStudy = StudyToolbox.getSourceStudyDB( parStudy );
	
	String redirHost = RedirectToolbox.getRedirectForStudy( is, parStudy );
	if (redirHost != null) {
		response.sendRedirect(redirHost+ "/cases/getrep.jsp?" + RedirectToolbox.getRedirectParams( is ) );
		return;
	}

	try {
		if ( !StudyToolbox.isOrder( parStudy ) && ProxyToolbox.checkAndProxy( is, parStudy, false ) ) {
			logger.syslog(Syslog.LOG_INFO, "getrep request for " + parStudy + " has been proxied to owner device" );
			return;
		}
	}
	catch (Throwable th) {
		logger.syslog(Syslog.LOG_ERR, "Exception " + Helper.throwable2String( th ) );
		return;
	}

	String parLock = request.getParameter("lock");
	if (parLock == null)
		parLock = "Lock";

%><%-- functions and constants moved to ReportToolbox--%><%

	if (!ReportToolbox.checkUserAgent(is))
		return;

	boolean bRight = false;

	if (is.regRights != null) // transcribe and set status right might be enough as well
		bRight = is.regRights.indexOf("R") != -1 || is.regRights.indexOf("T") != -1 || is.regRights.indexOf("G") != -1;

	String studyDirName = RepositoryHandler.getLocation(RepositoryHandler.DATA, parStudy);
	ReportToolbox.moveOldReportToDicomData(studyDirName, parStudy);

	if (!bRight && is.regRights != null) {
		// Lock is enabled with transcription and/or edit rights
		// remove these rights
		is.regRights = Helper.replace(is.regRights,"E","");
	}

	Properties prpHeaders = new Properties();
	Properties prpTimes = Report.getReportModified(is, parStudy, parLock, prpHeaders);

	if (!bRight)
		prpHeaders.setProperty("IMLock","NORIGHT");

	if (null != prpHeaders.getProperty("IMLockOwner"))
		response.setHeader("IMLockOwner",prpHeaders.getProperty("IMLockOwner"));
	if (null != prpHeaders.getProperty("IMLockAge"))
		response.setHeader("IMLockAge",prpHeaders.getProperty("IMLockAge"));
	if (null != prpHeaders.getProperty("IMLock"))
		response.setHeader("IMLock",prpHeaders.getProperty("IMLock"));
	if (null != prpHeaders.getProperty("IMLockID"))
		response.setHeader("IMLockID",prpHeaders.getProperty("IMLockID"));
	if (null != prpHeaders.getProperty("IMAuthentication"))
		response.setHeader("IMAuthentication",prpHeaders.getProperty("IMAuthentication"));
	if ("true".equals(prpHeaders.getProperty("IM_INTERRUPTED")))
		response.setHeader("IMLock","INTERRUPTED");

	int nWaitTime = 30000;
	int nElapsed = 0;

	while (ReportToolbox.hasNewerReport(prpTimes, parStudy) && nElapsed < nWaitTime) {
		Thread.sleep(50);
		nElapsed += 50;
	}

	if (ReportToolbox.hasNewerReport(prpTimes, parStudy)) {
		response.setHeader("IMReport","MODIFIED");
		if (bRight)
			IMLock.lockStudy(is, parStudy, "Unlock", new Properties());
	}

	int res = ReportToolbox.parseReport(is, parStudy);
	if (res == ReportToolbox.PR_INVALID_VERSION) {
		// This should not be happen with new (SR) reports
		// itt meg lehetne hivni a convertert, es ujra probalkozni
		out.println("INVALID REPORT VERSION");
	}

	if (true) {
		// For avoiding extra newline(s)
		return;
	}
%>
