<%--
 * Component: cases
 *
 * Description:
 *  Interface for saving reports used by the viewer and remote dotcom servers.
 *
 * Parameters (multipart):
 *
 *   cLogFile     Crash log file
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
--%><%@
	page import="imagemed.util.*,imagemed.imsession.*,java.util.*,java.io.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%!

	/**
	 * Adds log files uploaded by the viewer to vewer info log file.
	 *
	 * @param is        Session for original request headers
	 * @param mr        Multipart request having the uploaded files
	 * @param logFile   Path to the viewer info log file
	 *
	 * @throws IOException if an I/O error occurs
	 */
	static synchronized void addToViewerLog(IMSession is, MultipartRequest mr, String logFile) throws IOException {
		BufferedWriter bw = new BufferedWriter(new FileWriter(logFile, true)); // open file in append mode
		
		bw.write("@@@ ");
		bw.write(Helper.getTimeDate());
		bw.write(" Viewer Info");
		bw.newLine();
		String viewerAgent = is.request.getHeader("ViewerAgent");
		String viewerVersion = is.request.getHeader("ViewerVersion");
		String viewerClient = is.request.getHeader("ViewerClient");
		bw.write("### ViewerAgent: ");
		bw.write(viewerAgent == null ? "Unrecognized" : viewerAgent);
		bw.newLine();
		bw.write("### ViewerVersion: ");
		bw.write(viewerVersion == null ? "Unrecognized" : viewerVersion);
		bw.newLine();
		bw.write("### ViewerClient: ");
		bw.write(viewerClient == null ? "Unrecognized" : viewerClient);
		bw.newLine();

		if (mr == null) {
			bw.write("### Crashinfo file is missing/corrupted");
			bw.newLine();
		}
		else {
			for (Enumeration<String> e = mr.getParameterNames(); e.hasMoreElements();) {
				String parName = e.nextElement();
				String parVals[] = mr.getParameterValues(parName);
				if (parVals == null)
					continue;
				for (int i = 0 ; i < parVals.length ; i++) {
					bw.write("### ");
					bw.write(parName);
					bw.write("[" + i + "]");
					bw.newLine();
	
					char buf[] = new char[2048];
					int nRead = -1;
					FileReader fr = new FileReader(parVals[i]);
					while (-1 < (nRead = fr.read(buf))) {
						bw.write(buf, 0, nRead);
					}
					fr.close();
					bw.newLine();
				}
			}
		}
		bw.close();
	}

%><%
	IMSession is = new IMSession( request, response, out );
	MultipartRequest mp = null;
	try {
		mp = new MultipartRequest( is, IMEnvBase.getEnv("TMP") );
	}
	catch ( EOFException eofe ) {}
	
	addToViewerLog( is, mp, IMEnvBase.getEnv( "LOG" ) + "/viewerinfo.log" );

%>OK<%

	if ( true ) {
		// For avoiding extra newline(s)
		return;
	}
%>
