<%--
 * Component: cases
 *
 * WEB interface for getting/sending/deleting/listing/overwriting reports templates.
 *
 * cOper : describes what to do: 
 *     read      : get a template
 *     list      : list available templates
 *     write     : put a template
 *     overwrite : put a template over an existing one
 *     delete    : delete a template
 *
 * cTemplate : name of the template to read/write/overwrite/delete (not needed for 'list')
 *
--%><%@page import="imagemed.jsputil.CannedReportManager.CannedReport"%>
<%@page import="imagemed.jsputil.CannedReportManager"%>
<%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%@
	page import="imagemed.imsession.*, imagemed.users.*, imagemed.util.*, java.io.*, imagemed.jsputil.DotcomToolbox"

%><%

	IMSession is = new IMSession( request, response, out );

	response.setStatus( HttpServletResponse.SC_OK );

	if ( !is.regOK() ) {
		return;
	}

	String parOper = request.getParameter( "cOper" );
	String parTemplate = request.getParameter( "cTemplate" );
	String parContent = request.getParameter( "cContent" );

	if ( parOper == null || parOper.length() == 0 ) {
		response.setStatus( HttpServletResponse.SC_BAD_REQUEST );
		response.setHeader( "Error", "Required parameter 'cOper' is missing!" );
		return;
	}
	if ( !"list".equals( parOper ) && ( parTemplate == null || parTemplate.length() == 0) ) {
		response.setStatus( HttpServletResponse.SC_BAD_REQUEST );
		response.setHeader( "Error", "Required parameter 'cTemplate' is missing!" );
		return;
	}

	if ( "list".equals( parOper ) ) {
		UserFile templatesDir = is.getUser().getDir().getUserFile( "report_templates" );
		response.setContentType( "text/plain" );
		if ( !templatesDir.exists() ) {
			if ( !templatesDir.mkdirs() ) {
				response.setHeader( "Error", "Could not create templates directory!" );
			}
		}
		else {
			String[] fileNames = Helper.getDirectoryContentAsStringArray( templatesDir.toString(), "*.tmplt" );
			for ( int i = 0; i < fileNames.length; i++ ) {
				out.println( fileNames[ i ].substring( 0, fileNames[ i ].length() - 6 ) );
			}
		}
		return;
	}

	UserFile templateFile = is.getUser().getDir().getUserFile( "report_templates/" + parTemplate + ".tmplt" );

	if ( "read".equals( parOper ) ) {
		if ( !templateFile.exists() ) {
			response.setStatus(HttpServletResponse.SC_NOT_FOUND);
			response.setHeader( "Error", "Template file \"" + parTemplate + "\" for user \"" + is.regID + "\" not found!" );
			return;
		}
		response.setContentType( "text/plain" );
		String result = CannedReportManager.toLegacy( Helper.readTextFile( templateFile.toString() ) );
		response.setContentLength( result.length() );
		out.print( result );
		return;
	}

	if ( "overwrite".equals( parOper ) ) {
		if ( templateFile.exists() ) {
			templateFile.toFile().delete();
		}
		parOper = "write";
	}
	if ( "write".equals( parOper ) ) {
		if ( templateFile.exists() ) {
			response.setStatus( HttpServletResponse.SC_CONFLICT );
			response.setHeader( "Error", "Template file \"" + parTemplate + "\" for user \"" + is.regID + "\" already exists!" );
			return;
		}
		if ( parContent == null ) {
			StringBuffer strBuf = new StringBuffer( "" );
			BufferedReader reader = new BufferedReader( new InputStreamReader( request.getInputStream() ) );
			String line = reader.readLine();
			while ( line != null ) {
				strBuf.append( line );
				line = reader.readLine();
				if ( line != null ) {
					strBuf.append( "\n" );
				}
				parContent = strBuf.toString();
			}	
		}
		if ("true".equals(request.getParameter("cFromBrowser"))) {
			CannedReportManager crm = new CannedReportManager(is.getUser(), false);
			CannedReport cr = crm.createTemplate( parTemplate, parContent );
			String[] modalities = is.imRequest.getVals( "cModality" );
			if (modalities != null && modalities.length > 0) {
				cr.setProperty( CannedReport.MODALITIES, modalities );
			}
			cr.save();
		}
		else {
			if ( templateFile.prepareForWrite() ) {
				Helper.writeTextFile( templateFile.toString(), parContent );
				templateFile.proliferate( ProliferateMode.NORMAL );
			}
			else {
				response.setStatus( HttpServletResponse.SC_INTERNAL_SERVER_ERROR );
				response.setHeader( "Error", "The template file \"" + parTemplate + "\" could not be created for user \"" + is.regID + "\"." );
			}
		}
		return;
	}
	if ( "delete".equals( parOper ) ) {
		if ( !templateFile.exists() ) {
			response.setStatus( HttpServletResponse.SC_NOT_FOUND );
			response.setHeader( "Error", "Template file \"" + parTemplate + "\" for user \"" + is.regID + "\" not found!" );
			return;
		}
		CannedReportManager.deleteTemplate(is.getUser(), parTemplate);
		return;
	}
	
	response.setStatus( HttpServletResponse.SC_BAD_REQUEST );
	response.setHeader( "Error", "Unknown operation: " + parOper );

	if ( true ) {
		// For avoiding extra newline(s)
		return;
	}
%>