<%-- 
 * Component: cases
 *
 * Description:
 *   Quick View Window to show a DICOM image
 
 *   Quick View Window has got two parts (frames).
 *   The top is the quick view.
 *   The bottom contains DICOM dump links.
 *
 * Params:
 *    cFileName - File Name of the object to show
 *    cI          Frame Number within the object
 *    cX          Maximum X size
 *    cY          Maximum Y size
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
--%><%@page import="imagemed.types.date.IMTypeDt"%>
<%@
	page errorPage="../main/exceptionHandler.jsp"

%><%@
	page import="imagemed.http.IMRequest, imagemed.util.Helper, imagemed.imtables.*, imagemed.types.*, java.util.*, java.sql.*, imagemed.imsession.*, imagemed.jsputil.*, imagemed.util.*"

%><%
	IMSession is = new IMSession( request, response, out );

	if ( !is.regOK( false ) ) {
		return;
	}

	String parStudy = request.getParameter( "cStudy" );
	
%><HTML><HEAD><TITLE>View objects</TITLE>
<STYLE type="text/css">
img {
	margin: 4px;
}

</STYLE>

<SCRIPT language="JavaScript">

	function onStudySelected( study ) {
		var frm = getelementbyid( 'selectedStudyFrom' );
		if ( frm ) {
			var ss = getelementbyid( 'selstudy' );
			if ( ss ) {
				ss.value = study;
			}

			frm.submit();
		}
	}

	function showFilters( event, elem ) {
		var divFilter = document.getElementById( 'filterdiv' );
		divFilter.style.top = ( calcElementTop( elem ) + 30 ) + 'px';
		divFilter.style.left = '160px';
		divFilter.style.display = "block";
		divFilter.style.visibility = "visible";
	}

	function hideFilters() {
		var divFilter = document.getElementById( 'filterdiv' );
		divFilter.style.display = "none";
		divFilter.style.visibility = "hidden";
	}
	
</SCRIPT>
<%
imagemed.tables.Table.printCommonScript(is);
%>
</HEAD>
<BODY>
<DIV class="BgMedDark" style="padding: 5px; font-weight: bold;" onmouseover="showFilters( event, this )" onmouseout="hideFilters()">
<%
	String sourceStudy = null;
	if ( parStudy == null ) {
		out.println( LocalizedMessage.getSimpleMessage( "CASES_VIEWOBJS_NO_STUDY_SELECTED" ) );
	}
	else {
		ResultSet res = IMEnv.getDB().prepareStatement( "select * from " + IMEnvBase.getEnv( "STUDYTBL" ) + " where STYIUID='" + parStudy + "'" ).executeQuery();
		if ( res.next() ) {
			String pname = IMBaseFieldManager.DEFAULTFIELDMANAGER.displayText( res.getString( "PNAME" ), "PANM" );
			String date = ((IMTypeDt) IMType.getTypeFor( "Dt" )).displayDateOnly( res.getString( "THEDATETIME" ) );
			String modality = IMBaseFieldManager.DEFAULTFIELDMANAGER.displayText( res.getString( "MODALITY" ), "MODA" );
			sourceStudy = res.getString( "SRCSTUDY" );
			%><%= LocalizedMessage.getSimpleMessage( "CASES_VIEWOBJS_SELECTED_FOR_PURGE" ) %> <%= pname %> - <%= date %> - <%= modality %><% 
			res.close();
		}
		else {
			out.println( LocalizedMessage.getSimpleMessage( "CASES_VIEWOBJS_STUDY_NOT_FOUND_SELECT_ANOTHER" ) );
		}
	}
%>
</DIV>
<FORM id="selectedStudyFrom" METHOD="POST" style="display: inline">
<INPUT id=selstudy TYPE="HIDDEN" NAME="cStudy" VALUE="<%= Helper.htmlEncode( parStudy ) %>">
<%
	for( Enumeration<?> e = request.getParameterNames(); e.hasMoreElements() ; ) {
		String n = (String) e.nextElement();
		String[] v = request.getParameterValues( n );
		if ( v == null ) {
			continue;
		}
		for ( int i = 0; i < v.length; i++ ) {
			if ( "cStudy".equals( n ) ) {
				continue;
			}
			%><INPUT TYPE="HIDDEN" NAME="<%= Helper.htmlEncode( n ) %>" VALUE="<%= Helper.htmlEncode( v[ i ] ) %>">
<%
		}
	}
%>
</FORM>
<DIV id=filterdiv class="popup" style="display:none; padding: 15px; z-index: 999;">
<%
	Hashtable<String, String[]> requestPars = is.imRequest.getParTable();
	Properties filters = imagemed.actions.DcDelete.getObjectFilters( requestPars );

	if ( filters.isEmpty() ) {
		out.println( LocalizedMessage.getSimpleMessage( "CASES_VIEWOBJS_NO_OBJ_FILTER_SET" ) );
	}
	else {
		out.println( LocalizedMessage.getSimpleMessage( "CASES_VIEWOBJS_OBJ_FILTERS" ) + ":<BR>" );
	}

	// List filters
	for( Enumeration<?> e = filters.propertyNames(); e.hasMoreElements() ; ) {
		String n = (String) e.nextElement();
		String v = filters.getProperty( n );

		%><%= IMBaseFieldManager.staticGetUiName( n ) %>: <I><%= IMBaseFieldManager.DEFAULTFIELDMANAGER.displayFilter( v, n ) %></I><BR>
		<%
	}

	
%>
</DIV>
<%
	if ( parStudy == null ) {
		out.println( "</BODY></HTML>" );
		return;
	}


	String redirHost = RedirectToolbox.getRedirectForStudy( is, parStudy );
	if ( redirHost == null ) {
		redirHost = "";
	}

	String thSize = "256x256";
	int thCols = 256;
	int thRows = 256;

	QuickViewIconPrinter qvIcon = new QuickViewIconPrinter( out, redirHost, false, false );

	QuickViewImages qvImages = imagemed.actions.DcDelete.rmiGetPreviewImages( null, filters, parStudy, sourceStudy );
	
	Vector<QuickViewImages.QuickViewSeries> qvSeries = qvImages.getSeries();
	if ( qvSeries.isEmpty() ) {
		%><CENTER><BR><B><%= LocalizedMessage.getSimpleMessage( "CASES_VIEWOBJS_NO_OBJ_SELECTED_STUDY" ) %></B><BR></CENTER><%
	}
	else {
		for ( QuickViewImages.QuickViewSeries series : qvSeries ) {
			Vector<QuickViewImages.QuickViewObject> seriesObjects = series.getObjects();
			for ( QuickViewImages.QuickViewObject obj : seriesObjects ) {
				String fname = obj.getFileName();
				
				if ( obj instanceof QuickViewImages.QuickViewNonImageObject ) {
					QuickViewImages.QuickViewNonImageObject niObj = ( QuickViewImages.QuickViewNonImageObject ) obj;
					qvIcon.print( qvImages.getSeriesStudy(), fname, niObj.getSOPClassUID(), niObj.getInstanceNumber(), true );
					continue;
				}
	
				// image objects
				QuickViewImages.QuickViewImageObject imgObj = ( QuickViewImages.QuickViewImageObject ) obj;
				
				int frames = imgObj.getFrameCount();
				int cols = imgObj.getCols();
				int rows = imgObj.getRows();
				String wname = fname.replace( '.', '_' );

				int thnc1 = thCols;
				int thnr1 = thRows;
				float vr = (float) cols / rows;
				if ( vr < 1 )
					thnc1 *= vr;
				if ( vr > 1 )
					thnr1 /= vr;
				
				for ( int i = 1; i <= frames; i++ ) {
					String imgname = fname + "_" + Integer.toString( i );
				
					out.print( "<IMG src=\"" + redirHost + "/cases/frame.jsp?f=" + qvImages.getSeriesStudy() + "/" + imgname + "." + thSize + "w.jpg\"" );
					out.println( " width=" + thnc1 + " height=" + thnr1 + " alt=\"" + fname + " (" + cols + "x" + rows + ")\" border=0>" );
				}
			} // for obj

			out.println( "<BR>" );
		} // for series
	} // if

%>
</BODY>
</HTML>